package scenic3;

import scenic3.util.PathUtil;

public class ActionPath implements Comparable<ActionPath> {
    
    public final String path;
    public final String method;
    
    public ActionPath(String path, String method) {
        this.path = path;
        this.method = method == null ? "" : method;
    }

    @Override
    public int compareTo(ActionPath other) {
        int c = PathUtil.countSlash(other.path) - PathUtil.countSlash(this.path);
        if (c != 0) return c;
        c = other.path.compareTo(this.path);
        if (c != 0) return c;
        return other.method.compareTo(this.method);
    }

    @Override
    public int hashCode() {
        final int prime = 31;
        int result = 1;
        result = prime * result + ((method == null) ? 0 : method.hashCode());
        result = prime * result + ((path == null) ? 0 : path.hashCode());
        return result;
    }

    @Override
    public boolean equals(Object obj) {
        if (this == obj) return true;
        if (obj == null) return false;
        if (getClass() != obj.getClass()) return false;
        ActionPath other = (ActionPath) obj;
        if (method == null) {
            if (other.method != null) return false;
        } else if (!method.equals(other.method)) return false;
        if (path == null) {
            if (other.path != null) return false;
        } else if (!path.equals(other.path)) return false;
        return true;
    }
    
}
