package scenic3;

import java.util.regex.Pattern;

/**
 * 
 * @author shuji.w6e
 * @since 0.1.0
 */
public class StaticUrlMatcher implements UrlMatcher {
    private final Pattern[] patterns;

    /**
     * Constructor
     * @param patterns
     */
    public StaticUrlMatcher(String... patterns) {
        this.patterns = new Pattern[patterns.length];
        for (int i = 0; i < patterns.length; i++) {
            this.patterns[i] = Pattern.compile(patterns[i].replace(".", "\\.").replace("*", ".*"));
        }
    }

    @Override
    public ScenicController match(String path, String method) {
        return match(path);
    }

    public ScenicController match(String path) {
        for (Pattern pattern : this.patterns) {
            if (pattern.matcher(path).matches()) return ScenicController.STATIC_CONTROLLER;
        }
        return null;
    }
    
    /*
     * (non-Javadoc)
     * @see scenic3.UrlMatcher#getPageClassName()
     */
    @Override
    public String getPageClassName() {
        throw new UnsupportedOperationException("This object is StaticUrlMatcher.");
    }
}
