package scenic3.apt;

import java.io.IOException;
import java.io.PrintWriter;

/**
 * Code generator.
 * @author shuji.w6e
 * @since 0.1.0
 */
public abstract class CodeGenerator {

    /** PrintWriter */
    PrintWriter writer;

    /**
     * A constructor.
     * @param writer
     * @throws IOException
     */
    protected CodeGenerator(PrintWriter writer) throws IOException {
        if (writer == null) throw new IllegalArgumentException("writer is null.");
        this.writer = writer;
    }

    /**
     * Generate code.
     */
    public abstract void generate() throws UnsupportedArgumentException;

    /**
     * print character sequence.
     * @param c character sequence
     */
    protected void p(CharSequence c) {
        this.writer.println(c);
    }

    /**
     * print formated string
     * @param f
     * @param args
     */
    protected void p(String f, Object... args) {
        this.writer.println(String.format(f, args));
    }

    /**
     * print a new line.
     */
    protected void p() {
        this.writer.println();
    }
}
