package scenic3.apt;

import java.util.Comparator;

import scenic3.util.PathUtil;

/**
 * Comparator for path pattern
 * @author shuji.w6e
 * @since 0.2.0
 */
public class PathPatternComparator implements Comparator<String> {

    /*
     * (non-Javadoc)
     * @see java.util.Comparator#compare(java.lang.Object, java.lang.Object)
     */
    @Override
    public int compare(String path1, String path2) {
        if (path1 == null && path2 == null) return 0;
        if (path1 == null) return -1;
        if (path2 == null) return 1;
        int c = PathUtil.countSlash(path2) - PathUtil.countSlash(path1);
        if (c != 0) return c;
        return path2.compareTo(path1);
    }
}
