package scenic3.apt;

import java.util.SortedMap;

import scenic3.ActionPath;

/**
 * Description for UrlMatcher class.
 * @author shuji.w6e
 * @since 0.1.0
 */
public class UrlMatcherDesc {
    /** a package name of UrlMacher */
    public final String packageName;
    /** a class name of UrlMacher */
    public final String className;
    /** a class name of Page */
    public final String pageClassName;
    /** page path of UrlMacher */
    public final String pagePath;
    /** url patterns of UrlMacher */
    public final SortedMap<ActionPath, String> patterns;
    /** default url pattern of UrlMacher */
    public final String defaultPattern;

    /**
     * Constructor.
     * @param packageName
     * @param className
     * @param pageClassName
     * @param pagePath
     * @param patterns
     */
    public UrlMatcherDesc(String packageName, String className, String pageClassName, String pagePath, SortedMap<ActionPath, String> patterns, String defaultPattern) {
        this.packageName = packageName;
        this.className = className;
        this.pageClassName = pageClassName;
        this.pagePath = pagePath;
        this.patterns = patterns;
        this.defaultPattern = defaultPattern;
    }

}
