package scenic3.apt.processor;

import java.util.Map.Entry;

import com.sun.mirror.apt.AnnotationProcessorEnvironment;
import com.sun.mirror.apt.Messager;
import com.sun.mirror.declaration.AnnotationMirror;
import com.sun.mirror.declaration.AnnotationTypeElementDeclaration;
import com.sun.mirror.declaration.AnnotationValue;

public class EnvSupport {
    protected final AnnotationProcessorEnvironment env;
    // protected final ProcessingEnvironment processingEnv;
    // protected final RoundEnvironment roundEnv;
    // /** Messager */
    protected final Messager messager;

    // /** Utility for Types */
    // protected final Types types;
    // /** Utility for Elements */
    // protected final Elements elms;
    //
    public EnvSupport(AnnotationProcessorEnvironment env) {
        this.env = env;
        // this.roundEnv = roundEnv;
        this.messager = env.getMessager();
        // this.types = processingEnv.getTypeUtils();
        // this.elms = processingEnv.getElementUtils();
    }

    protected boolean isTypeOf(AnnotationMirror mirror, String qName) {
        return mirror.getAnnotationType().getDeclaration().getQualifiedName().equals(qName);
    }

    protected boolean containsValue(AnnotationMirror mirror, String name) {
        for (Entry<AnnotationTypeElementDeclaration, AnnotationValue> entry : mirror.getElementValues().entrySet()) {
            if (entry.getKey().getSimpleName().equals(name)) return true;
        }
        return false;
    }
    
    @SuppressWarnings("unchecked")
    protected <T> T getValue(AnnotationMirror mirror, String name) {
        for (Entry<AnnotationTypeElementDeclaration, AnnotationValue> entry : mirror.getElementValues().entrySet()) {
            if (entry.getKey().getSimpleName().equals(name)) {
                return (T) entry.getValue().getValue();
            }
        }
        throw new IllegalArgumentException("name=" + name);
    }
    
    
    public void printNotice(String msg) {
        messager.printNotice(msg);
    }

    public void printWarning(String msg) {
        messager.printWarning(msg);
    }

    public void printError(String msg) {
        messager.printError(msg);
    }

}
