package scenic3.apt.processor;

import java.util.Arrays;
import java.util.Collection;
import java.util.Collections;
import java.util.HashSet;
import java.util.Set;

import scenic3.apt.AnnotationConstants;

import com.sun.mirror.apt.AnnotationProcessor;
import com.sun.mirror.apt.AnnotationProcessorEnvironment;
import com.sun.mirror.apt.AnnotationProcessorFactory;
import com.sun.mirror.declaration.AnnotationTypeDeclaration;

/**
 * AnnotationProcessorFactory for Scenic3.
 * @author shuji.w6e
 * @since 0.1.0
 */
public class Scenic3ProcessorFactory implements AnnotationProcessorFactory {

    // Process any set of annotations
    private static final Collection<String> supportedAnnotations =
        Collections.unmodifiableCollection(Arrays.asList(AnnotationConstants.PAGE));

    @Override
    public Collection<String> supportedAnnotationTypes() {
        return supportedAnnotations;
    }

    /** the supported options */
    protected static final Collection<String> supportedOptions;
    static {
        Set<String> options = new HashSet<String>();
        options.add("slim3.rootPackage");
        options.add("debug");
        supportedOptions = Collections.unmodifiableCollection(options);
    }

    @Override
    public Collection<String> supportedOptions() {
        return supportedOptions;
    }

    @Override
    public AnnotationProcessor getProcessorFor(Set<AnnotationTypeDeclaration> atds, AnnotationProcessorEnvironment env) {
        return new Scenic3Processor(atds, env);
    }

}
