package scenic3.util;

/**
 * Utility
 * @author shuji.w6e
 * @since 0.1.0
 */
public class PathUtil {
    
    /**
     * 指定したパスが/で始まる場合にtrueを返す
     * @param path
     * @return
     */
    public static boolean startsWithSlash(String path) {
        if (path == null || path.length() == 0) return false;
        return path.charAt(0) == '/';
    }
    
    /**
     * 指定したパスが/で始まららない場合に、/を付与して返す
     * <p>
     * pathがnullの場合はnullを返す
     * </p>
     * @param path
     * @return
     */
    public static String appendStartSlashIfNeed(String path) {
        if (path != null && !startsWithSlash(path)) {
            return "/" + path;
        }
        return path;
    }

    public static boolean endsWithSlash(String path) {
        if (path == null || path.length() == 0) return false;
        return path.charAt(path.length() - 1) == '/';
    }

    public static String appendEndSlashIfNeed(String path) {
        if (path != null && !endsWithSlash(path)) {
            return path + "/";
        }
        return path;
    }

    /**
     * 指定した文字列に含まれる/の数を返す。
     * @param path
     * @return
     */
    public static int countSlash(String path) {
        if (path == null) throw new IllegalArgumentException();
        return path.split("/", -1).length - 1;
    }

}
